import secrets
from tornado.web import RequestHandler, HTTPError


class TestHandler(RequestHandler):
    def initialize(self, solvable_connector, token):
        self.solvable_connector = solvable_connector
        self.token = token

    async def get(self):
        self.solvable_connector.send('test', {})
        resp_token, resp_data = await self.solvable_connector.recv()
        if not secrets.compare_digest(self.token, resp_token):
            raise HTTPError(500, 'Solvable didn\'t provide initial token.')
        self.write(resp_data)
