from tornado.ioloop import IOLoop

from tfw.components.source_code_event_handler import SourceCodeEventHandler
from tfw.components.terminado_event_handler import TerminadoEventHandler
from tfw.components.process_managing_event_handler import ProcessManagingEventHandler
from tfw.config import tfwenv
from tfw.config.logs import logging
log = logging.getLogger(__name__)


if __name__ == '__main__':
    ide = SourceCodeEventHandler('webide', tfwenv.WEBIDE_WD)
    terminado = TerminadoEventHandler('shell')
    terminado.historymonitor.callbacks.append(lambda hist: log.debug('User executed command: "{}"'.format(hist[-1])))
    processmanager = ProcessManagingEventHandler('processmanager', ide.monitor)

    eventhandlers = {ide, terminado, processmanager}
    try:
        IOLoop.instance().start()
    finally:
        for eh in eventhandlers: eh.cleanup()
